
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega1280
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : Off
;Automatic register allocation : Off

	#pragma AVRPART ADMIN PART_NAME ATmega1280
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 8703
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x200

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU RAMPZ=0x3B
	.EQU EIND=0x3C
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x74
	.EQU XMCRB=0x75
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0200
	.EQU __SRAM_END=0x21FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_Sinewave:
	.DB  0x0,0x0,0xC9,0x0,0x92,0x1,0x5B,0x2
	.DB  0x24,0x3,0xED,0x3,0xB6,0x4,0x7E,0x5
	.DB  0x47,0x6,0x10,0x7,0xD9,0x7,0xA1,0x8
	.DB  0x6A,0x9,0x32,0xA,0xFB,0xA,0xC3,0xB
	.DB  0x8B,0xC,0x53,0xD,0x1B,0xE,0xE3,0xE
	.DB  0xAB,0xF,0x72,0x10,0x39,0x11,0x0,0x12
	.DB  0xC7,0x12,0x8E,0x13,0x55,0x14,0x1B,0x15
	.DB  0xE1,0x15,0xA7,0x16,0x6D,0x17,0x33,0x18
	.DB  0xF8,0x18,0xBD,0x19,0x82,0x1A,0x46,0x1B
	.DB  0xB,0x1C,0xCF,0x1C,0x93,0x1D,0x56,0x1E
	.DB  0x19,0x1F,0xDC,0x1F,0x9F,0x20,0x61,0x21
	.DB  0x23,0x22,0xE4,0x22,0xA6,0x23,0x67,0x24
	.DB  0x27,0x25,0xE7,0x25,0xA7,0x26,0x67,0x27
	.DB  0x26,0x28,0xE5,0x28,0xA3,0x29,0x61,0x2A
	.DB  0x1E,0x2B,0xDB,0x2B,0x98,0x2C,0x54,0x2D
	.DB  0x10,0x2E,0xCC,0x2E,0x86,0x2F,0x41,0x30
	.DB  0xFB,0x30,0xB4,0x31,0x6D,0x32,0x26,0x33
	.DB  0xDE,0x33,0x96,0x34,0x4D,0x35,0x3,0x36
	.DB  0xB9,0x36,0x6F,0x37,0x24,0x38,0xD8,0x38
	.DB  0x8C,0x39,0x3F,0x3A,0xF2,0x3A,0xA4,0x3B
	.DB  0x56,0x3C,0x7,0x3D,0xB7,0x3D,0x67,0x3E
	.DB  0x16,0x3F,0xC5,0x3F,0x73,0x40,0x20,0x41
	.DB  0xCD,0x41,0x79,0x42,0x25,0x43,0xD0,0x43
	.DB  0x7A,0x44,0x23,0x45,0xCC,0x45,0x74,0x46
	.DB  0x1C,0x47,0xC3,0x47,0x69,0x48,0xE,0x49
	.DB  0xB3,0x49,0x57,0x4A,0xFA,0x4A,0x9D,0x4B
	.DB  0x3F,0x4C,0xE0,0x4C,0x80,0x4D,0x20,0x4E
	.DB  0xBF,0x4E,0x5D,0x4F,0xFA,0x4F,0x97,0x50
	.DB  0x33,0x51,0xCE,0x51,0x68,0x52,0x1,0x53
	.DB  0x9A,0x53,0x32,0x54,0xC9,0x54,0x5F,0x55
	.DB  0xF4,0x55,0x89,0x56,0x1D,0x57,0xB0,0x57
	.DB  0x42,0x58,0xD3,0x58,0x63,0x59,0xF3,0x59
	.DB  0x81,0x5A,0xF,0x5B,0x9C,0x5B,0x28,0x5C
	.DB  0xB3,0x5C,0x3D,0x5D,0xC6,0x5D,0x4F,0x5E
	.DB  0xD6,0x5E,0x5D,0x5F,0xE2,0x5F,0x67,0x60
	.DB  0xEB,0x60,0x6E,0x61,0xF0,0x61,0x71,0x62
	.DB  0xF1,0x62,0x70,0x63,0xEE,0x63,0x6B,0x64
	.DB  0xE7,0x64,0x62,0x65,0xDD,0x65,0x56,0x66
	.DB  0xCE,0x66,0x45,0x67,0xBC,0x67,0x31,0x68
	.DB  0xA5,0x68,0x19,0x69,0x8B,0x69,0xFC,0x69
	.DB  0x6C,0x6A,0xDB,0x6A,0x4A,0x6B,0xB7,0x6B
	.DB  0x23,0x6C,0x8E,0x6C,0xF8,0x6C,0x61,0x6D
	.DB  0xC9,0x6D,0x30,0x6E,0x95,0x6E,0xFA,0x6E
	.DB  0x5E,0x6F,0xC0,0x6F,0x22,0x70,0x82,0x70
	.DB  0xE1,0x70,0x40,0x71,0x9D,0x71,0xF9,0x71
	.DB  0x54,0x72,0xAE,0x72,0x6,0x73,0x5E,0x73
	.DB  0xB5,0x73,0xA,0x74,0x5E,0x74,0xB1,0x74
	.DB  0x3,0x75,0x54,0x75,0xA4,0x75,0xF3,0x75
	.DB  0x40,0x76,0x8D,0x76,0xD8,0x76,0x22,0x77
	.DB  0x6B,0x77,0xB3,0x77,0xF9,0x77,0x3F,0x78
	.DB  0x83,0x78,0xC6,0x78,0x8,0x79,0x49,0x79
	.DB  0x89,0x79,0xC7,0x79,0x4,0x7A,0x41,0x7A
	.DB  0x7C,0x7A,0xB5,0x7A,0xEE,0x7A,0x25,0x7B
	.DB  0x5C,0x7B,0x91,0x7B,0xC4,0x7B,0xF7,0x7B
	.DB  0x29,0x7C,0x59,0x7C,0x88,0x7C,0xB6,0x7C
	.DB  0xE2,0x7C,0xE,0x7D,0x38,0x7D,0x61,0x7D
	.DB  0x89,0x7D,0xB0,0x7D,0xD5,0x7D,0xF9,0x7D
	.DB  0x1C,0x7E,0x3E,0x7E,0x5E,0x7E,0x7E,0x7E
	.DB  0x9C,0x7E,0xB9,0x7E,0xD4,0x7E,0xEF,0x7E
	.DB  0x8,0x7F,0x20,0x7F,0x37,0x7F,0x4C,0x7F
	.DB  0x61,0x7F,0x74,0x7F,0x86,0x7F,0x96,0x7F
	.DB  0xA6,0x7F,0xB4,0x7F,0xC1,0x7F,0xCD,0x7F
	.DB  0xD7,0x7F,0xE0,0x7F,0xE8,0x7F,0xEF,0x7F
	.DB  0xF5,0x7F,0xF9,0x7F,0xFC,0x7F,0xFE,0x7F
	.DB  0xFF,0x7F,0xFE,0x7F,0xFC,0x7F,0xF9,0x7F
	.DB  0xF5,0x7F,0xEF,0x7F,0xE8,0x7F,0xE0,0x7F
	.DB  0xD7,0x7F,0xCD,0x7F,0xC1,0x7F,0xB4,0x7F
	.DB  0xA6,0x7F,0x96,0x7F,0x86,0x7F,0x74,0x7F
	.DB  0x61,0x7F,0x4C,0x7F,0x37,0x7F,0x20,0x7F
	.DB  0x8,0x7F,0xEF,0x7E,0xD4,0x7E,0xB9,0x7E
	.DB  0x9C,0x7E,0x7E,0x7E,0x5E,0x7E,0x3E,0x7E
	.DB  0x1C,0x7E,0xF9,0x7D,0xD5,0x7D,0xB0,0x7D
	.DB  0x89,0x7D,0x61,0x7D,0x38,0x7D,0xE,0x7D
	.DB  0xE2,0x7C,0xB6,0x7C,0x88,0x7C,0x59,0x7C
	.DB  0x29,0x7C,0xF7,0x7B,0xC4,0x7B,0x91,0x7B
	.DB  0x5C,0x7B,0x25,0x7B,0xEE,0x7A,0xB5,0x7A
	.DB  0x7C,0x7A,0x41,0x7A,0x4,0x7A,0xC7,0x79
	.DB  0x89,0x79,0x49,0x79,0x8,0x79,0xC6,0x78
	.DB  0x83,0x78,0x3F,0x78,0xF9,0x77,0xB3,0x77
	.DB  0x6B,0x77,0x22,0x77,0xD8,0x76,0x8D,0x76
	.DB  0x40,0x76,0xF3,0x75,0xA4,0x75,0x54,0x75
	.DB  0x3,0x75,0xB1,0x74,0x5E,0x74,0xA,0x74
	.DB  0xB5,0x73,0x5E,0x73,0x6,0x73,0xAE,0x72
	.DB  0x54,0x72,0xF9,0x71,0x9D,0x71,0x40,0x71
	.DB  0xE1,0x70,0x82,0x70,0x22,0x70,0xC0,0x6F
	.DB  0x5E,0x6F,0xFA,0x6E,0x95,0x6E,0x30,0x6E
	.DB  0xC9,0x6D,0x61,0x6D,0xF8,0x6C,0x8E,0x6C
	.DB  0x23,0x6C,0xB7,0x6B,0x4A,0x6B,0xDB,0x6A
	.DB  0x6C,0x6A,0xFC,0x69,0x8B,0x69,0x19,0x69
	.DB  0xA5,0x68,0x31,0x68,0xBC,0x67,0x45,0x67
	.DB  0xCE,0x66,0x56,0x66,0xDD,0x65,0x62,0x65
	.DB  0xE7,0x64,0x6B,0x64,0xEE,0x63,0x70,0x63
	.DB  0xF1,0x62,0x71,0x62,0xF0,0x61,0x6E,0x61
	.DB  0xEB,0x60,0x67,0x60,0xE2,0x5F,0x5D,0x5F
	.DB  0xD6,0x5E,0x4F,0x5E,0xC6,0x5D,0x3D,0x5D
	.DB  0xB3,0x5C,0x28,0x5C,0x9C,0x5B,0xF,0x5B
	.DB  0x81,0x5A,0xF3,0x59,0x63,0x59,0xD3,0x58
	.DB  0x42,0x58,0xB0,0x57,0x1D,0x57,0x89,0x56
	.DB  0xF4,0x55,0x5F,0x55,0xC9,0x54,0x32,0x54
	.DB  0x9A,0x53,0x1,0x53,0x68,0x52,0xCE,0x51
	.DB  0x33,0x51,0x97,0x50,0xFA,0x4F,0x5D,0x4F
	.DB  0xBF,0x4E,0x20,0x4E,0x80,0x4D,0xE0,0x4C
	.DB  0x3F,0x4C,0x9D,0x4B,0xFA,0x4A,0x57,0x4A
	.DB  0xB3,0x49,0xE,0x49,0x69,0x48,0xC3,0x47
	.DB  0x1C,0x47,0x74,0x46,0xCC,0x45,0x23,0x45
	.DB  0x7A,0x44,0xD0,0x43,0x25,0x43,0x79,0x42
	.DB  0xCD,0x41,0x20,0x41,0x73,0x40,0xC5,0x3F
	.DB  0x16,0x3F,0x67,0x3E,0xB7,0x3D,0x7,0x3D
	.DB  0x56,0x3C,0xA4,0x3B,0xF2,0x3A,0x3F,0x3A
	.DB  0x8C,0x39,0xD8,0x38,0x24,0x38,0x6F,0x37
	.DB  0xB9,0x36,0x3,0x36,0x4D,0x35,0x96,0x34
	.DB  0xDE,0x33,0x26,0x33,0x6D,0x32,0xB4,0x31
	.DB  0xFB,0x30,0x41,0x30,0x86,0x2F,0xCC,0x2E
	.DB  0x10,0x2E,0x54,0x2D,0x98,0x2C,0xDB,0x2B
	.DB  0x1E,0x2B,0x61,0x2A,0xA3,0x29,0xE5,0x28
	.DB  0x26,0x28,0x67,0x27,0xA7,0x26,0xE7,0x25
	.DB  0x27,0x25,0x67,0x24,0xA6,0x23,0xE4,0x22
	.DB  0x23,0x22,0x61,0x21,0x9F,0x20,0xDC,0x1F
	.DB  0x19,0x1F,0x56,0x1E,0x93,0x1D,0xCF,0x1C
	.DB  0xB,0x1C,0x46,0x1B,0x82,0x1A,0xBD,0x19
	.DB  0xF8,0x18,0x33,0x18,0x6D,0x17,0xA7,0x16
	.DB  0xE1,0x15,0x1B,0x15,0x55,0x14,0x8E,0x13
	.DB  0xC7,0x12,0x0,0x12,0x39,0x11,0x72,0x10
	.DB  0xAB,0xF,0xE3,0xE,0x1B,0xE,0x53,0xD
	.DB  0x8B,0xC,0xC3,0xB,0xFB,0xA,0x32,0xA
	.DB  0x6A,0x9,0xA1,0x8,0xD9,0x7,0x10,0x7
	.DB  0x47,0x6,0x7E,0x5,0xB6,0x4,0xED,0x3
	.DB  0x24,0x3,0x5B,0x2,0x92,0x1,0xC9,0x0
	.DB  0x0,0x0,0x37,0xFF,0x6E,0xFE,0xA5,0xFD
	.DB  0xDC,0xFC,0x13,0xFC,0x4A,0xFB,0x82,0xFA
	.DB  0xB9,0xF9,0xF0,0xF8,0x27,0xF8,0x5F,0xF7
	.DB  0x96,0xF6,0xCE,0xF5,0x5,0xF5,0x3D,0xF4
	.DB  0x75,0xF3,0xAD,0xF2,0xE5,0xF1,0x1D,0xF1
	.DB  0x55,0xF0,0x8E,0xEF,0xC7,0xEE,0x0,0xEE
	.DB  0x39,0xED,0x72,0xEC,0xAB,0xEB,0xE5,0xEA
	.DB  0x1F,0xEA,0x59,0xE9,0x93,0xE8,0xCD,0xE7
	.DB  0x8,0xE7,0x43,0xE6,0x7E,0xE5,0xBA,0xE4
	.DB  0xF5,0xE3,0x31,0xE3,0x6D,0xE2,0xAA,0xE1
	.DB  0xE7,0xE0,0x24,0xE0,0x61,0xDF,0x9F,0xDE
	.DB  0xDD,0xDD,0x1C,0xDD,0x5A,0xDC,0x99,0xDB
	.DB  0xD9,0xDA,0x19,0xDA,0x59,0xD9,0x99,0xD8
	.DB  0xDA,0xD7,0x1B,0xD7,0x5D,0xD6,0x9F,0xD5
	.DB  0xE2,0xD4,0x25,0xD4,0x68,0xD3,0xAC,0xD2
	.DB  0xF0,0xD1,0x34,0xD1,0x7A,0xD0,0xBF,0xCF
	.DB  0x5,0xCF,0x4C,0xCE,0x93,0xCD,0xDA,0xCC
	.DB  0x22,0xCC,0x6A,0xCB,0xB3,0xCA,0xFD,0xC9
	.DB  0x47,0xC9,0x91,0xC8,0xDC,0xC7,0x28,0xC7
	.DB  0x74,0xC6,0xC1,0xC5,0xE,0xC5,0x5C,0xC4
	.DB  0xAA,0xC3,0xF9,0xC2,0x49,0xC2,0x99,0xC1
	.DB  0xEA,0xC0,0x3B,0xC0,0x8D,0xBF,0xE0,0xBE
	.DB  0x33,0xBE,0x87,0xBD,0xDB,0xBC,0x30,0xBC
	.DB  0x86,0xBB,0xDD,0xBA,0x34,0xBA,0x8C,0xB9
	.DB  0xE4,0xB8,0x3D,0xB8,0x97,0xB7,0xF2,0xB6
	.DB  0x4D,0xB6,0xA9,0xB5,0x6,0xB5,0x63,0xB4
	.DB  0xC1,0xB3,0x20,0xB3,0x80,0xB2,0xE0,0xB1
	.DB  0x41,0xB1,0xA3,0xB0,0x6,0xB0,0x69,0xAF
	.DB  0xCD,0xAE,0x32,0xAE,0x98,0xAD,0xFF,0xAC
	.DB  0x66,0xAC,0xCE,0xAB,0x37,0xAB,0xA1,0xAA
	.DB  0xC,0xAA,0x77,0xA9,0xE3,0xA8,0x50,0xA8
	.DB  0xBE,0xA7,0x2D,0xA7,0x9D,0xA6,0xD,0xA6
	.DB  0x7F,0xA5,0xF1,0xA4,0x64,0xA4,0xD8,0xA3
	.DB  0x4D,0xA3,0xC3,0xA2,0x3A,0xA2,0xB1,0xA1
	.DB  0x2A,0xA1,0xA3,0xA0,0x1E,0xA0,0x99,0x9F
	.DB  0x15,0x9F,0x92,0x9E,0x10,0x9E,0x8F,0x9D
	.DB  0xF,0x9D,0x90,0x9C,0x12,0x9C,0x95,0x9B
	.DB  0x19,0x9B,0x9E,0x9A,0x23,0x9A,0xAA,0x99
	.DB  0x32,0x99,0xBB,0x98,0x44,0x98,0xCF,0x97
	.DB  0x5B,0x97,0xE7,0x96,0x75,0x96,0x4,0x96
	.DB  0x94,0x95,0x25,0x95,0xB6,0x94,0x49,0x94
	.DB  0xDD,0x93,0x72,0x93,0x8,0x93,0x9F,0x92
	.DB  0x37,0x92,0xD0,0x91,0x6B,0x91,0x6,0x91
	.DB  0xA2,0x90,0x40,0x90,0xDE,0x8F,0x7E,0x8F
	.DB  0x1F,0x8F,0xC0,0x8E,0x63,0x8E,0x7,0x8E
	.DB  0xAC,0x8D,0x52,0x8D,0xFA,0x8C,0xA2,0x8C
	.DB  0x4B,0x8C,0xF6,0x8B,0xA2,0x8B,0x4F,0x8B
	.DB  0xFD,0x8A,0xAC,0x8A,0x5C,0x8A,0xD,0x8A
	.DB  0xC0,0x89,0x73,0x89,0x28,0x89,0xDE,0x88
	.DB  0x95,0x88,0x4D,0x88,0x7,0x88,0xC1,0x87
	.DB  0x7D,0x87,0x3A,0x87,0xF8,0x86,0xB7,0x86
	.DB  0x77,0x86,0x39,0x86,0xFC,0x85,0xBF,0x85
	.DB  0x84,0x85,0x4B,0x85,0x12,0x85,0xDB,0x84
	.DB  0xA4,0x84,0x6F,0x84,0x3C,0x84,0x9,0x84
	.DB  0xD7,0x83,0xA7,0x83,0x78,0x83,0x4A,0x83
	.DB  0x1E,0x83,0xF2,0x82,0xC8,0x82,0x9F,0x82
	.DB  0x77,0x82,0x50,0x82,0x2B,0x82,0x7,0x82
	.DB  0xE4,0x81,0xC2,0x81,0xA2,0x81,0x82,0x81
	.DB  0x64,0x81,0x47,0x81,0x2C,0x81,0x11,0x81
	.DB  0xF8,0x80,0xE0,0x80,0xC9,0x80,0xB4,0x80
	.DB  0x9F,0x80,0x8C,0x80,0x7A,0x80,0x6A,0x80
	.DB  0x5A,0x80,0x4C,0x80,0x3F,0x80,0x33,0x80
	.DB  0x29,0x80,0x20,0x80,0x18,0x80,0x11,0x80
	.DB  0xB,0x80,0x7,0x80,0x4,0x80,0x2,0x80
	.DB  0x1,0x80,0x2,0x80,0x4,0x80,0x7,0x80
	.DB  0xB,0x80,0x11,0x80,0x18,0x80,0x20,0x80
	.DB  0x29,0x80,0x33,0x80,0x3F,0x80,0x4C,0x80
	.DB  0x5A,0x80,0x6A,0x80,0x7A,0x80,0x8C,0x80
	.DB  0x9F,0x80,0xB4,0x80,0xC9,0x80,0xE0,0x80
	.DB  0xF8,0x80,0x11,0x81,0x2C,0x81,0x47,0x81
	.DB  0x64,0x81,0x82,0x81,0xA2,0x81,0xC2,0x81
	.DB  0xE4,0x81,0x7,0x82,0x2B,0x82,0x50,0x82
	.DB  0x77,0x82,0x9F,0x82,0xC8,0x82,0xF2,0x82
	.DB  0x1E,0x83,0x4A,0x83,0x78,0x83,0xA7,0x83
	.DB  0xD7,0x83,0x9,0x84,0x3C,0x84,0x6F,0x84
	.DB  0xA4,0x84,0xDB,0x84,0x12,0x85,0x4B,0x85
	.DB  0x84,0x85,0xBF,0x85,0xFC,0x85,0x39,0x86
	.DB  0x77,0x86,0xB7,0x86,0xF8,0x86,0x3A,0x87
	.DB  0x7D,0x87,0xC1,0x87,0x7,0x88,0x4D,0x88
	.DB  0x95,0x88,0xDE,0x88,0x28,0x89,0x73,0x89
	.DB  0xC0,0x89,0xD,0x8A,0x5C,0x8A,0xAC,0x8A
	.DB  0xFD,0x8A,0x4F,0x8B,0xA2,0x8B,0xF6,0x8B
	.DB  0x4B,0x8C,0xA2,0x8C,0xFA,0x8C,0x52,0x8D
	.DB  0xAC,0x8D,0x7,0x8E,0x63,0x8E,0xC0,0x8E
	.DB  0x1F,0x8F,0x7E,0x8F,0xDE,0x8F,0x40,0x90
	.DB  0xA2,0x90,0x6,0x91,0x6B,0x91,0xD0,0x91
	.DB  0x37,0x92,0x9F,0x92,0x8,0x93,0x72,0x93
	.DB  0xDD,0x93,0x49,0x94,0xB6,0x94,0x25,0x95
	.DB  0x94,0x95,0x4,0x96,0x75,0x96,0xE7,0x96
	.DB  0x5B,0x97,0xCF,0x97,0x44,0x98,0xBB,0x98
	.DB  0x32,0x99,0xAA,0x99,0x23,0x9A,0x9E,0x9A
	.DB  0x19,0x9B,0x95,0x9B,0x12,0x9C,0x90,0x9C
	.DB  0xF,0x9D,0x8F,0x9D,0x10,0x9E,0x92,0x9E
	.DB  0x15,0x9F,0x99,0x9F,0x1E,0xA0,0xA3,0xA0
	.DB  0x2A,0xA1,0xB1,0xA1,0x3A,0xA2,0xC3,0xA2
	.DB  0x4D,0xA3,0xD8,0xA3,0x64,0xA4,0xF1,0xA4
	.DB  0x7F,0xA5,0xD,0xA6,0x9D,0xA6,0x2D,0xA7
	.DB  0xBE,0xA7,0x50,0xA8,0xE3,0xA8,0x77,0xA9
	.DB  0xC,0xAA,0xA1,0xAA,0x37,0xAB,0xCE,0xAB
	.DB  0x66,0xAC,0xFF,0xAC,0x98,0xAD,0x32,0xAE
	.DB  0xCD,0xAE,0x69,0xAF,0x6,0xB0,0xA3,0xB0
	.DB  0x41,0xB1,0xE0,0xB1,0x80,0xB2,0x20,0xB3
	.DB  0xC1,0xB3,0x63,0xB4,0x6,0xB5,0xA9,0xB5
	.DB  0x4D,0xB6,0xF2,0xB6,0x97,0xB7,0x3D,0xB8
	.DB  0xE4,0xB8,0x8C,0xB9,0x34,0xBA,0xDD,0xBA
	.DB  0x86,0xBB,0x30,0xBC,0xDB,0xBC,0x87,0xBD
	.DB  0x33,0xBE,0xE0,0xBE,0x8D,0xBF,0x3B,0xC0
	.DB  0xEA,0xC0,0x99,0xC1,0x49,0xC2,0xF9,0xC2
	.DB  0xAA,0xC3,0x5C,0xC4,0xE,0xC5,0xC1,0xC5
	.DB  0x74,0xC6,0x28,0xC7,0xDC,0xC7,0x91,0xC8
	.DB  0x47,0xC9,0xFD,0xC9,0xB3,0xCA,0x6A,0xCB
	.DB  0x22,0xCC,0xDA,0xCC,0x93,0xCD,0x4C,0xCE
	.DB  0x5,0xCF,0xBF,0xCF,0x7A,0xD0,0x34,0xD1
	.DB  0xF0,0xD1,0xAC,0xD2,0x68,0xD3,0x25,0xD4
	.DB  0xE2,0xD4,0x9F,0xD5,0x5D,0xD6,0x1B,0xD7
	.DB  0xDA,0xD7,0x99,0xD8,0x59,0xD9,0x19,0xDA
	.DB  0xD9,0xDA,0x99,0xDB,0x5A,0xDC,0x1C,0xDD
	.DB  0xDD,0xDD,0x9F,0xDE,0x61,0xDF,0x24,0xE0
	.DB  0xE7,0xE0,0xAA,0xE1,0x6D,0xE2,0x31,0xE3
	.DB  0xF5,0xE3,0xBA,0xE4,0x7E,0xE5,0x43,0xE6
	.DB  0x8,0xE7,0xCD,0xE7,0x93,0xE8,0x59,0xE9
	.DB  0x1F,0xEA,0xE5,0xEA,0xAB,0xEB,0x72,0xEC
	.DB  0x39,0xED,0x0,0xEE,0xC7,0xEE,0x8E,0xEF
	.DB  0x55,0xF0,0x1D,0xF1,0xE5,0xF1,0xAD,0xF2
	.DB  0x75,0xF3,0x3D,0xF4,0x5,0xF5,0xCE,0xF5
	.DB  0x96,0xF6,0x5F,0xF7,0x27,0xF8,0xF0,0xF8
	.DB  0xB9,0xF9,0x82,0xFA,0x4A,0xFB,0x13,0xFC
	.DB  0xDC,0xFC,0xA5,0xFD,0x6E,0xFE,0x37,0xFF

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRA,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x600

	.CSEG
;
;#include <mega1280.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
;
;// Declare your global variables here
;
;
;#define FIX_MPY(DEST,A,B)       DEST = ((long)(A) * (long)(B))>>15
;
;#define N_WAVE          1024    /* dimension of Sinewave[] */
;#define LOG2_N_WAVE     10      /* log2(N_WAVE) */
;#define N_LOUD          100     /* dimension of Loudampl[] */
;#ifndef fixed
;#define fixed int
;#endif
;
;flash const fixed Sinewave[N_WAVE]; /* placed at end of this file for clarity */
;fixed mr[N_WAVE],mi[N_WAVE];
;fixed fix_mpy(fixed a, fixed b);
;
;/*
;        fix_fft() - perform fast Fourier transform.
;
;        if n>0 FFT is done, if n<0 inverse FFT is done
;        fr[n],fi[n] are real,imaginary arrays, INPUT AND RESULT.
;        size of data = 2**m
;        set inverse to 0=dft, 1=idft
;*/
;int fix_fft(fixed fr[], fixed fi[], int m, int inverse)
; 0000 001D {

	.CSEG
_fix_fft:
; 0000 001E         int mr,nn,i,j,l,k,istep, n, scale, shift;
; 0000 001F         fixed qr,qi,tr,ti,wr,wi,t;
; 0000 0020 
; 0000 0021         n = 1<<m;
	SBIW R28,28
	CALL __SAVELOCR6
;	fr -> Y+40
;	fi -> Y+38
;	m -> Y+36
;	inverse -> Y+34
;	mr -> R16,R17
;	nn -> R18,R19
;	i -> R20,R21
;	j -> Y+32
;	l -> Y+30
;	k -> Y+28
;	istep -> Y+26
;	n -> Y+24
;	scale -> Y+22
;	shift -> Y+20
;	qr -> Y+18
;	qi -> Y+16
;	tr -> Y+14
;	ti -> Y+12
;	wr -> Y+10
;	wi -> Y+8
;	t -> Y+6
	LDD  R30,Y+36
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	STD  Y+24,R30
	STD  Y+24+1,R31
; 0000 0022 
; 0000 0023         if(n > N_WAVE)
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	CPI  R26,LOW(0x401)
	LDI  R30,HIGH(0x401)
	CPC  R27,R30
	BRLT _0x3
; 0000 0024                 return -1;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2000001
; 0000 0025 
; 0000 0026         mr = 0;
_0x3:
	__GETWRN 16,17,0
; 0000 0027         nn = n - 1;
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	SBIW R30,1
	MOVW R18,R30
; 0000 0028         scale = 0;
	LDI  R30,LOW(0)
	STD  Y+22,R30
	STD  Y+22+1,R30
; 0000 0029 
; 0000 002A         /* decimation in time - re-order data */
; 0000 002B         for(m=1; m<=nn; ++m) {
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+36,R30
	STD  Y+36+1,R31
_0x5:
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	CP   R18,R26
	CPC  R19,R27
	BRGE PC+3
	JMP _0x6
; 0000 002C                 l = n;
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	STD  Y+30,R30
	STD  Y+30+1,R31
; 0000 002D                 do {
_0x8:
; 0000 002E                         l >>= 1;
	LDD  R30,Y+30
	LDD  R31,Y+30+1
	ASR  R31
	ROR  R30
	STD  Y+30,R30
	STD  Y+30+1,R31
; 0000 002F                 } while(mr+l > nn);
	LDD  R26,Y+30
	LDD  R27,Y+30+1
	ADD  R26,R16
	ADC  R27,R17
	CP   R18,R26
	CPC  R19,R27
	BRLT _0x8
; 0000 0030                 mr = (mr & (l-1)) + l;
	SBIW R30,1
	AND  R30,R16
	AND  R31,R17
	LDD  R26,Y+30
	LDD  R27,Y+30+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R16,R30
; 0000 0031 
; 0000 0032                 if(mr <= m) continue;
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xA
	RJMP _0x4
; 0000 0033                 tr = fr[m];
_0xA:
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 0034                 fr[m] = fr[mr];
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0035                 fr[mr] = tr;
	MOVW R30,R16
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	STD  Z+0,R26
	STD  Z+1,R27
; 0000 0036                 ti = fi[m];
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 0037                 fi[m] = fi[mr];
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0038                 fi[mr] = ti;
	MOVW R30,R16
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	STD  Z+0,R26
	STD  Z+1,R27
; 0000 0039         }
_0x4:
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	ADIW R30,1
	STD  Y+36,R30
	STD  Y+36+1,R31
	RJMP _0x5
_0x6:
; 0000 003A 
; 0000 003B         l = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+30,R30
	STD  Y+30+1,R31
; 0000 003C         k = LOG2_N_WAVE-1;
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	STD  Y+28,R30
	STD  Y+28+1,R31
; 0000 003D         while(l < n) {
_0xB:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	LDD  R26,Y+30
	LDD  R27,Y+30+1
	CP   R26,R30
	CPC  R27,R31
	BRLT PC+3
	JMP _0xD
; 0000 003E                 if(inverse) {
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	SBIW R30,0
	BRNE PC+3
	JMP _0xE
; 0000 003F                         /* variable scaling, depending upon data */
; 0000 0040                         shift = 0;
	LDI  R30,LOW(0)
	STD  Y+20,R30
	STD  Y+20+1,R30
; 0000 0041                         for(i=0; i<n; ++i) {
	__GETWRN 20,21,0
_0x10:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	CP   R20,R30
	CPC  R21,R31
	BRGE _0x11
; 0000 0042                                 j = fr[i];
	MOVW R30,R20
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+32,R30
	STD  Y+32+1,R31
; 0000 0043                                 if(j < 0)
	LDD  R26,Y+33
	TST  R26
	BRPL _0x12
; 0000 0044                                         j = -j;
	CALL __ANEGW1
	STD  Y+32,R30
	STD  Y+32+1,R31
; 0000 0045                                 m = fi[i];
_0x12:
	MOVW R30,R20
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+36,R30
	STD  Y+36+1,R31
; 0000 0046                                 if(m < 0)
	LDD  R26,Y+37
	TST  R26
	BRPL _0x13
; 0000 0047                                         m = -m;
	CALL __ANEGW1
	STD  Y+36,R30
	STD  Y+36+1,R31
; 0000 0048                                 if(j > 16383 || m > 16383) {
_0x13:
	LDD  R26,Y+32
	LDD  R27,Y+32+1
	CPI  R26,LOW(0x4000)
	LDI  R30,HIGH(0x4000)
	CPC  R27,R30
	BRGE _0x15
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	CPI  R26,LOW(0x4000)
	LDI  R30,HIGH(0x4000)
	CPC  R27,R30
	BRLT _0x14
_0x15:
; 0000 0049                                         shift = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 004A                                         break;
	RJMP _0x11
; 0000 004B                                 }
; 0000 004C                         }
_0x14:
	__ADDWRN 20,21,1
	RJMP _0x10
_0x11:
; 0000 004D                         if(shift)
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	SBIW R30,0
	BREQ _0x17
; 0000 004E                                 ++scale;
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ADIW R30,1
	STD  Y+22,R30
	STD  Y+22+1,R31
; 0000 004F                 } else {
_0x17:
	RJMP _0x18
_0xE:
; 0000 0050                         /* fixed scaling, for proper normalization -
; 0000 0051                            there will be log2(n) passes, so this
; 0000 0052                            results in an overall factor of 1/n,
; 0000 0053                            distributed to maximize arithmetic accuracy. */
; 0000 0054                         shift = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 0055                 }
_0x18:
; 0000 0056                 /* it may not be obvious, but the shift will be performed
; 0000 0057                    on each data point exactly once, during this pass. */
; 0000 0058                 istep = l << 1;
	LDD  R30,Y+30
	LDD  R31,Y+30+1
	LSL  R30
	ROL  R31
	STD  Y+26,R30
	STD  Y+26+1,R31
; 0000 0059                 for(m=0; m<l; ++m) {
	LDI  R30,LOW(0)
	STD  Y+36,R30
	STD  Y+36+1,R30
_0x1A:
	LDD  R30,Y+30
	LDD  R31,Y+30+1
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	CP   R26,R30
	CPC  R27,R31
	BRLT PC+3
	JMP _0x1B
; 0000 005A                         j = m << k;
	LDD  R30,Y+28
	CALL __LSLW12
	STD  Y+32,R30
	STD  Y+32+1,R31
; 0000 005B                         /* 0 <= j < N_WAVE/2 */
; 0000 005C                         wr =  Sinewave[j+N_WAVE/4];
	LSL  R30
	ROL  R31
	__ADDW1FN _Sinewave,512
	CALL __GETW1PF
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 005D                         wi = -Sinewave[j];
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	LDI  R26,LOW(_Sinewave*2)
	LDI  R27,HIGH(_Sinewave*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	CALL __ANEGW1
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 005E                         if(inverse)
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	SBIW R30,0
	BREQ _0x1C
; 0000 005F                                 wi = -wi;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL __ANEGW1
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 0060                         if(shift) {
_0x1C:
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	SBIW R30,0
	BREQ _0x1D
; 0000 0061                                 wr >>= 1;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ASR  R31
	ROR  R30
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 0062                                 wi >>= 1;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ASR  R31
	ROR  R30
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 0063                         }
; 0000 0064                         for(i=m; i<n; i+=istep) {
_0x1D:
	__GETWRS 20,21,36
_0x1F:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	CP   R20,R30
	CPC  R21,R31
	BRLT PC+3
	JMP _0x20
; 0000 0065                                 j = i + l;
	LDD  R30,Y+30
	LDD  R31,Y+30+1
	ADD  R30,R20
	ADC  R31,R21
	STD  Y+32,R30
	STD  Y+32+1,R31
; 0000 0066                                         tr = fix_mpy(wr,fr[j]) -
; 0000 0067 fix_mpy(wi,fi[j]);
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _fix_mpy
	PUSH R31
	PUSH R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _fix_mpy
	POP  R26
	POP  R27
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+14,R26
	STD  Y+14+1,R27
; 0000 0068                                         ti = fix_mpy(wr,fi[j]) +
; 0000 0069 fix_mpy(wi,fr[j]);
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _fix_mpy
	PUSH R31
	PUSH R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _fix_mpy
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 006A                                 qr = fr[i];
	MOVW R30,R20
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0000 006B                                 qi = fi[i];
	MOVW R30,R20
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+16,R30
	STD  Y+16+1,R31
; 0000 006C                                 if(shift) {
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	SBIW R30,0
	BREQ _0x21
; 0000 006D                                         qr >>= 1;
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ASR  R31
	ROR  R30
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0000 006E                                         qi >>= 1;
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ASR  R31
	ROR  R30
	STD  Y+16,R30
	STD  Y+16+1,R31
; 0000 006F                                 }
; 0000 0070                                 fr[j] = qr - tr;
_0x21:
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0071                                 fi[j] = qi - ti;
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0072                                 fr[i] = qr + tr;
	MOVW R30,R20
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0073                                 fi[i] = qi + ti;
	MOVW R30,R20
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0074                         }
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__ADDWRR 20,21,30,31
	RJMP _0x1F
_0x20:
; 0000 0075                 }
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	ADIW R30,1
	STD  Y+36,R30
	STD  Y+36+1,R31
	RJMP _0x1A
_0x1B:
; 0000 0076                 --k;
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	SBIW R30,1
	STD  Y+28,R30
	STD  Y+28+1,R31
; 0000 0077                 l = istep;
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	STD  Y+30,R30
	STD  Y+30+1,R31
; 0000 0078         }
	RJMP _0xB
_0xD:
; 0000 0079 
; 0000 007A         return scale;
	LDD  R30,Y+22
	LDD  R31,Y+22+1
_0x2000001:
	CALL __LOADLOCR6
	ADIW R28,42
	RET
; 0000 007B }
;
;/*
;        fix_mpy() - fixed-point multiplication
;*/
;fixed fix_mpy(fixed a, fixed b)
; 0000 0081 {
_fix_mpy:
; 0000 0082         FIX_MPY(a,a,b);
;	a -> Y+2
;	b -> Y+0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __CWD2
	LD   R30,Y
	LDD  R31,Y+1
	CALL __CWD1
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(15)
	CALL __ASRD12
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 0083         return a;
	ADIW R28,4
	RET
; 0000 0084 }
;
;#if N_WAVE != 1024
;        ERROR: N_WAVE != 1024
;#endif
;flash const fixed Sinewave[1024] = {
;      0,    201,    402,    603,    804,   1005,   1206,   1406,
;   1607,   1808,   2009,   2209,   2410,   2610,   2811,   3011,
;   3211,   3411,   3611,   3811,   4011,   4210,   4409,   4608,
;   4807,   5006,   5205,   5403,   5601,   5799,   5997,   6195,
;   6392,   6589,   6786,   6982,   7179,   7375,   7571,   7766,
;   7961,   8156,   8351,   8545,   8739,   8932,   9126,   9319,
;   9511,   9703,   9895,  10087,  10278,  10469,  10659,  10849,
;  11038,  11227,  11416,  11604,  11792,  11980,  12166,  12353,
;  12539,  12724,  12909,  13094,  13278,  13462,  13645,  13827,
;  14009,  14191,  14372,  14552,  14732,  14911,  15090,  15268,
;  15446,  15623,  15799,  15975,  16150,  16325,  16499,  16672,
;  16845,  17017,  17189,  17360,  17530,  17699,  17868,  18036,
;  18204,  18371,  18537,  18702,  18867,  19031,  19194,  19357,
;  19519,  19680,  19840,  20000,  20159,  20317,  20474,  20631,
;  20787,  20942,  21096,  21249,  21402,  21554,  21705,  21855,
;  22004,  22153,  22301,  22448,  22594,  22739,  22883,  23027,
;  23169,  23311,  23452,  23592,  23731,  23869,  24006,  24143,
;  24278,  24413,  24546,  24679,  24811,  24942,  25072,  25201,
;  25329,  25456,  25582,  25707,  25831,  25954,  26077,  26198,
;  26318,  26437,  26556,  26673,  26789,  26905,  27019,  27132,
;  27244,  27355,  27466,  27575,  27683,  27790,  27896,  28001,
;  28105,  28208,  28309,  28410,  28510,  28608,  28706,  28802,
;  28897,  28992,  29085,  29177,  29268,  29358,  29446,  29534,
;  29621,  29706,  29790,  29873,  29955,  30036,  30116,  30195,
;  30272,  30349,  30424,  30498,  30571,  30643,  30713,  30783,
;  30851,  30918,  30984,  31049,
;  31113,  31175,  31236,  31297,
;  31356,  31413,  31470,  31525,  31580,  31633,  31684,  31735,
;  31785,  31833,  31880,  31926,  31970,  32014,  32056,  32097,
;  32137,  32176,  32213,  32249,  32284,  32318,  32350,  32382,
;  32412,  32441,  32468,  32495,  32520,  32544,  32567,  32588,
;  32609,  32628,  32646,  32662,  32678,  32692,  32705,  32717,
;  32727,  32736,  32744,  32751,  32757,  32761,  32764,  32766,
;  32767,  32766,  32764,  32761,  32757,  32751,  32744,  32736,
;  32727,  32717,  32705,  32692,  32678,  32662,  32646,  32628,
;  32609,  32588,  32567,  32544,  32520,  32495,  32468,  32441,
;  32412,  32382,  32350,  32318,  32284,  32249,  32213,  32176,
;  32137,  32097,  32056,  32014,  31970,  31926,  31880,  31833,
;  31785,  31735,  31684,  31633,  31580,  31525,  31470,  31413,
;  31356,  31297,  31236,  31175,  31113,  31049,  30984,  30918,
;  30851,  30783,  30713,  30643,  30571,  30498,  30424,  30349,
;  30272,  30195,  30116,  30036,  29955,  29873,  29790,  29706,
;  29621,  29534,  29446,  29358,  29268,  29177,  29085,  28992,
;  28897,  28802,  28706,  28608,  28510,  28410,  28309,  28208,
;  28105,  28001,  27896,  27790,  27683,  27575,  27466,  27355,
;  27244,  27132,  27019,  26905,  26789,  26673,  26556,  26437,
;  26318,  26198,  26077,  25954,  25831,  25707,  25582,  25456,
;  25329,  25201,  25072,  24942,  24811,  24679,  24546,  24413,
;  24278,  24143,  24006,  23869,  23731,  23592,  23452,  23311,
;  23169,  23027,  22883,  22739,  22594,  22448,  22301,  22153,
;  22004,  21855,  21705,  21554,  21402,  21249,  21096,  20942,
;  20787,  20631,  20474,  20317,  20159,  20000,  19840,  19680,
;  19519,  19357,  19194,  19031,  18867,  18702,  18537,  18371,
;  18204,  18036,  17868,  17699,  17530,  17360,  17189,  17017,
;  16845,  16672,  16499,  16325,  16150,  15975,  15799,  15623,
;  15446,  15268,  15090,  14911,  14732,  14552,  14372,  14191,
;  14009,  13827,  13645,  13462,  13278,  13094,  12909,  12724,
;  12539,  12353,  12166,  11980,  11792,  11604,  11416,  11227,
;  11038,  10849,  10659,  10469,  10278,  10087,   9895,   9703,
;   9511,   9319,   9126,   8932,   8739,   8545,   8351,   8156,
;   7961,   7766,   7571,   7375,   7179,   6982,   6786,   6589,
;   6392,   6195,   5997,   5799,   5601,   5403,   5205,   5006,
;   4807,   4608,   4409,   4210,   4011,   3811,   3611,   3411,
;   3211,   3011,   2811,   2610,   2410,   2209,   2009,   1808,
;   1607,   1406,   1206,   1005,    804,    603,    402,    201,
;      0,   -201,   -402,   -603,   -804,  -1005,  -1206,  -1406,
;  -1607,  -1808,  -2009,  -2209,  -2410,  -2610,  -2811,  -3011,
;  -3211,  -3411,  -3611,  -3811,  -4011,  -4210,  -4409,  -4608,
;  -4807,  -5006,  -5205,  -5403,  -5601,  -5799,  -5997,  -6195,
;  -6392,  -6589,  -6786,  -6982,  -7179,  -7375,  -7571,  -7766,
;  -7961,  -8156,  -8351,  -8545,  -8739,  -8932,  -9126,  -9319,
;  -9511,  -9703,  -9895, -10087, -10278, -10469, -10659, -10849,
; -11038, -11227, -11416, -11604, -11792, -11980, -12166, -12353,
; -12539, -12724, -12909, -13094, -13278, -13462, -13645, -13827,
; -14009, -14191, -14372, -14552, -14732, -14911, -15090, -15268,
; -15446, -15623, -15799, -15975, -16150, -16325, -16499, -16672,
; -16845, -17017, -17189, -17360, -17530, -17699, -17868, -18036,
; -18204, -18371, -18537, -18702, -18867, -19031, -19194, -19357,
; -19519, -19680, -19840, -20000, -20159, -20317, -20474, -20631,
; -20787, -20942, -21096, -21249, -21402, -21554, -21705, -21855,
; -22004, -22153, -22301, -22448, -22594, -22739, -22883, -23027,
; -23169, -23311, -23452, -23592, -23731, -23869, -24006, -24143,
; -24278, -24413, -24546, -24679, -24811, -24942, -25072, -25201,
; -25329, -25456, -25582, -25707, -25831, -25954, -26077, -26198,
; -26318, -26437, -26556, -26673, -26789, -26905, -27019, -27132,
; -27244, -27355, -27466, -27575, -27683, -27790, -27896, -28001,
; -28105, -28208, -28309, -28410, -28510, -28608, -28706, -28802,
; -28897, -28992, -29085, -29177, -29268, -29358, -29446, -29534,
; -29621, -29706, -29790, -29873, -29955, -30036, -30116, -30195,
; -30272, -30349, -30424, -30498, -30571, -30643, -30713, -30783,
; -30851, -30918, -30984, -31049, -31113, -31175, -31236, -31297,
; -31356, -31413, -31470, -31525, -31580, -31633, -31684, -31735,
; -31785, -31833, -31880, -31926, -31970, -32014, -32056, -32097,
; -32137, -32176, -32213, -32249, -32284, -32318, -32350, -32382,
; -32412, -32441, -32468, -32495, -32520, -32544, -32567, -32588,
; -32609, -32628, -32646, -32662, -32678, -32692, -32705, -32717,
; -32727, -32736, -32744, -32751, -32757, -32761, -32764, -32766,
; -32767, -32766, -32764, -32761, -32757, -32751, -32744, -32736,
; -32727, -32717, -32705, -32692, -32678, -32662, -32646, -32628,
; -32609, -32588, -32567, -32544, -32520, -32495, -32468, -32441,
; -32412, -32382, -32350, -32318, -32284, -32249, -32213, -32176,
; -32137, -32097, -32056, -32014, -31970, -31926, -31880, -31833,
; -31785, -31735, -31684, -31633, -31580, -31525, -31470, -31413,
; -31356, -31297, -31236, -31175, -31113, -31049, -30984, -30918,
; -30851, -30783, -30713, -30643, -30571, -30498, -30424, -30349,
; -30272, -30195, -30116, -30036, -29955, -29873, -29790, -29706,
; -29621, -29534, -29446, -29358, -29268, -29177, -29085, -28992,
; -28897, -28802, -28706, -28608, -28510, -28410, -28309, -28208,
; -28105, -28001, -27896, -27790, -27683, -27575, -27466, -27355,
; -27244, -27132, -27019, -26905, -26789, -26673, -26556, -26437,
; -26318, -26198, -26077, -25954, -25831, -25707, -25582, -25456,
; -25329, -25201, -25072, -24942, -24811, -24679, -24546, -24413,
; -24278, -24143, -24006, -23869, -23731, -23592, -23452, -23311,
; -23169, -23027, -22883, -22739, -22594, -22448, -22301, -22153,
; -22004, -21855, -21705, -21554, -21402, -21249, -21096, -20942,
; -20787, -20631, -20474, -20317, -20159, -20000, -19840, -19680,
; -19519, -19357, -19194, -19031, -18867, -18702, -18537, -18371,
; -18204, -18036, -17868, -17699, -17530, -17360, -17189, -17017,
; -16845, -16672, -16499, -16325, -16150, -15975, -15799, -15623,
; -15446, -15268, -15090, -14911, -14732, -14552, -14372, -14191,
; -14009, -13827, -13645, -13462, -13278, -13094, -12909, -12724,
; -12539, -12353, -12166, -11980, -11792, -11604, -11416, -11227,
; -11038, -10849, -10659, -10469, -10278, -10087,  -9895,  -9703,
;  -9511,  -9319,  -9126,  -8932,  -8739,  -8545,  -8351,  -8156,
;  -7961,  -7766,  -7571,  -7375,  -7179,  -6982,  -6786,  -6589,
;  -6392,  -6195,  -5997,  -5799,  -5601,  -5403,  -5205,  -5006,
;  -4807,  -4608,  -4409,  -4210,  -4011,  -3811,  -3611,  -3411,
;  -3211,  -3011,  -2811,  -2610,  -2410,  -2209,  -2009,  -1808,
;  -1607,  -1406,  -1206,  -1005,   -804,   -603,   -402,   -201,
;};
;
;
;
;void main(void)
; 0000 0110 {
_main:
; 0000 0111 // Declare your local variables here
; 0000 0112 
; 0000 0113 // Input/Output Ports initialization
; 0000 0114 // Port A initialization
; 0000 0115 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
; 0000 0116 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0
; 0000 0117 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 0118 DDRA=0x01;
	LDI  R30,LOW(1)
	OUT  0x1,R30
; 0000 0119 
; 0000 011A 
; 0000 011B 
; 0000 011C while (1)
_0x22:
; 0000 011D       {
; 0000 011E       // Place your code here
; 0000 011F       PORTA=1;
	LDI  R30,LOW(1)
	OUT  0x2,R30
; 0000 0120       fix_fft(mr,mi,10,0);
	LDI  R30,LOW(_mr)
	LDI  R31,HIGH(_mr)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_mi)
	LDI  R31,HIGH(_mi)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _fix_fft
; 0000 0121       PORTA=0;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 0122 
; 0000 0123       }
	RJMP _0x22
; 0000 0124 }
_0x25:
	RJMP _0x25

	.DSEG
_mr:
	.BYTE 0x800
_mi:
	.BYTE 0x800

	.CSEG

	.CSEG
__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__ASRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __ASRD12R
__ASRD12L:
	ASR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRD12L
__ASRD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
